prism.run([ function () {
  
  //  Define the template for metadata translation
  var datasourceAliasing = {
    "tables": {},
    "formulas": {},
    "hierarchies": {},
    "titles": {},
    "columns": {
      "Candidate Custom Fields": {}
    }
  };

  //  Define which elasticube this applies to
  var secureElasticube = 'Job Candidates';

  //  Define the query url
  var queryUrl = '/api/datasources/' + secureElasticube + '/jaql';

  //  Define JAQL query to fetch the translations
  var queryPayload = {
    "datasource": "Job Candidates",
    "format": "json",
    "metadata":[
      {
        "jaql": {
                "table": "CustomFields",
                "column": "field_id",
                "dim": "[CustomFields.field_id]",
                "datatype": "text",
            }
        },{
            "jaql": {
          "table": "CustomFields",
          "column": "fieldName",
          "dim": "[CustomFields.fieldName]",
          "datatype": "text",
          "title": "fieldName"
        }
      }
    ]
  }

  //  Handler function for when deciding what metadata to display
  var datasourceProvider = function (datasourceId, resolve, reject) {

    //  Only run for a specific elasticube
    if (datasourceId.title == secureElasticube){
  
      //  get Angular's $http service for ajax requests
      var $http = prism.$injector.get('$http');

      //  Make API call to get the translations
      $http.post(queryUrl, queryPayload)
        .then(function (response) {

          //  Get the translations from the response
          var translations = $$get(response, 'data.values', []);

          //  Was the response valid?
          if (translations && translations.length) {

            //  Loop through each translation
            translations.forEach(function(row){

              //  Get the column name (ec name) and the label to use
              var columnId = row[0].text,
                columLabel = row[1].text;

              //  Save to the datasource alias object
              datasourceAliasing.columns["Candidate Custom Fields"][columnId] = columLabel;
              datasourceAliasing.titles[columnId] = columLabel;
            })
            
            return resolve(datasourceAliasing);
          } else {

            //  Invalid response
            return resolve();
          }
        })
        .catch(reject);
        
    } else {
      return resolve();
    }
  };

  //  Use event handler to register metadata handler function
  prism.on("beforealiascontextinit", function (ev, args) {
    var timeout = 5000;
    args.register(datasourceProvider, timeout);
  });

}]);